//#include "config.h"
#include <X11/Xlib.h>
#include <X11/extensions/XShm.h>
#include <X11/Xutil.h>
#include <X11/extensions/shape.h>
#include <X11/Xatom.h>
#include <X11/Xos.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>

/*
#include <sys/time.h>
#include "common.h"
#include "image.h"
#include "rend.h"
#include "rgba.h"
#include "ximage.h"
#include "color.h"
 */
#include "Imlib2.h"

void exposelist(void);


Display            *disp;
Window              win;
Window              win2;
Visual             *vis;
Colormap            cm;
int                 depth;
XSetWindowAttributes attr;
char *appToRun;

int main(int argc, char **argv)
{
   int                 w, h, x, y;
   Imlib_Image        im_bg1 = NULL;
   Imlib_Image        im_bg2 = NULL;
   XEvent              ev;
   const char         *display_name = getenv("DISPLAY");
   Imlib_Font          font;
   char                text[4096];
   Imlib_Image         buffer;
   Imlib_Image         back;
   Imlib_Image         bigback;
   Imlib_Color_Range   range;
   int  text_w, text_h,text_h2;

   if (display_name == NULL)
       display_name = ":0";
   disp = XOpenDisplay(display_name);
   if (disp == NULL)
     {
       fprintf(stderr, "Can't open display %s\n", display_name);
       return 1;
     }
  char home[1024];
  sprintf(home,"%s",getenv("HOME"));

  int screen=DefaultScreen(disp);
  int screenWidth=0;
  screenWidth=XDisplayWidth(disp,screen);
  screenWidth=80;
  int screenHeight;
  screenHeight=160;
  int screenX=10;
  int screenY=10;
  char *picname0;
  char *picname1;
  char *picname2;
  char *text1;
  char *text2;
  char *text3;
  char *text4;
  int xl=0;
  int yl=0;
  int mytoggle = 0;

//----arguments x y width height lower/raise(0/1) picture appToRun
  if ( argc != 12 ){
    printf("usage: iconweather x y width height bak_image image1 image2 text_date text_weather text_Tem text_wind \n");
    return 1;
  }

  sscanf(argv[1], "%d", &screenX);
  sscanf(argv[2], "%d", &screenY);
  sscanf(argv[3], "%d", &screenWidth);
  sscanf(argv[4], "%d", &screenHeight);
  picname0 = argv[5];
  picname1 = argv[6];
  picname2 = argv[7];
  text1 = argv[8];
  text2 = argv[9];
  text3 = argv[10];
  text4 = argv[11];

  vis = DefaultVisual(disp, DefaultScreen(disp));
  depth = DefaultDepth(disp, DefaultScreen(disp));
  cm = DefaultColormap(disp, DefaultScreen(disp));
  range = imlib_create_color_range();
  imlib_context_set_color_range(range);
  imlib_context_set_color(255, 255, 255, 255);
  imlib_add_color_to_color_range(0);
             /* add an orange color, semi-transparent 10 units from the first */
  imlib_context_set_color(255, 200, 10, 255);
  imlib_add_color_to_color_range(10);
             /* add black, fully transparent at the end 20 units away */
  imlib_context_set_color(70, 0, 0, 255);
  imlib_add_color_to_color_range(20);


  attr.override_redirect=True;
 
//win=XCreateWindow(disp,DefaultRootWindow(disp),screenX,screenY,screenWidth,screenHeight,0,CopyFromParent,InputOutput,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask|CWBorderPixel|CWSaveUnder|CWColormap|CWBackPixel,&attr);
  win=XCreateWindow(disp,DefaultRootWindow(disp),screenX,screenY,screenWidth,screenHeight,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);


//   win =  XCreateSimpleWindow(disp, DefaultRootWindow(disp), 0, 0, 100, 100, 0, 0, 0);

  XSelectInput(disp, win, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);

  XLowerWindow(disp,win);

   /**
    * Start rendering
    */

  imlib_context_set_display(disp);
  imlib_context_set_visual(vis);
  imlib_context_set_colormap(cm);
  imlib_context_set_drawable(win);
  imlib_context_set_dither(1);
  imlib_context_set_blend(0);
  imlib_context_set_color_modifier(NULL);

//--
  w=screenWidth;
  h=screenHeight;
  back = imlib_load_image(picname0);
  imlib_context_set_image(back);
  buffer = imlib_create_cropped_scaled_image(0, 0,imlib_image_get_width() ,imlib_image_get_height() , w , h);

  im_bg1 = imlib_load_image(picname1);
  if (strstr(picname2,(char *)"N/A")!=0)
    im_bg2 = imlib_load_image(picname2);
  imlib_context_set_image(im_bg1);
  int is=imlib_image_get_width();
  int ih=imlib_image_get_height();
  int d1=screenWidth-is;
  d1=d1/2;
  int d2=screenHeight-ih;
  d2=d2/2;


  imlib_context_set_image(im_bg1);
  imlib_context_set_blend(1);
  imlib_context_set_image(back);
  imlib_render_image_on_drawable(0, 0);
  imlib_context_set_image(im_bg1);
  imlib_render_image_on_drawable_at_size(d1-1, d2-1,is+2,ih+2);
  bigback=imlib_create_image_from_drawable( 0,0,0,w,h,1);

  if (strstr(picname2,(char *)"N/A")!=0)
  {
    imlib_context_set_blend(1);
    imlib_context_set_image(im_bg2);
    imlib_render_image_on_drawable_at_size(d1-1, d2-1,is+2,ih+2);
    bigback=imlib_create_image_from_drawable( 0,0,0,w,h,1);
  }  

  imlib_context_set_image(back);
  imlib_render_image_on_drawable(0, 0);
  if (strstr(picname2,(char *)"N/A")!=0)
  {
    imlib_context_set_image(im_bg1);
    imlib_render_image_on_drawable(d1-10, d2);
    imlib_context_set_image(im_bg2);
    imlib_render_image_on_drawable(d1+10, d2);
  } else {
    imlib_context_set_image(im_bg1);
    imlib_render_image_on_drawable(d1, d2);
  }
  back=imlib_create_image_from_drawable( 0,0,0,w,h,1);
  XMapWindow(disp, win);

  buffer = imlib_create_image(1000, 30);  
  font = imlib_load_font("Vera/8");
  imlib_context_set_font(font);
  imlib_context_set_color(0, 0, 0, 255);
  sprintf(text,title);
  imlib_get_text_size(text, &text_w, &text_h);
  text_h2=text_h;
  text_h=text_h*4+10;
  text_w=screenWidth;
  if (text_w>screenWidth)
    text_w=screenWidth;
  attr.override_redirect=True;
 
  win2=XCreateWindow(disp,DefaultRootWindow(disp),screenX,screenY,text_w+10,text_h+4,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);
  XLowerWindow(disp,win2);
  XLowerWindow(disp,win);
  XMapWindow(disp, win2);
  XMapWindow(disp, win);
  imlib_context_set_drawable(win2); 
   
  //           imlib_context_set_image(buffer);

             /* draw the range */
  imlib_context_set_image(buffer);
  imlib_image_fill_color_range_rectangle(0,0, text_w*4, text_h*2,
                                                   -45.0);
             /* free it */
        //     imlib_free_color_range();

  imlib_context_set_image(buffer);
  
  imlib_render_image_on_drawable(0, 0); 


  imlib_context_set_image(buffer);
  imlib_context_set_font(font);
  imlib_context_set_color(0, 0, 0, 255);
  imlib_text_draw(5,2,text1);
  imlib_text_draw(5,text_h2+4,text2);
  imlib_text_draw(5,text_h2*2+6,text3);
  imlib_text_draw(5,text_h2*3+8,text4);

             /* set the buffer image as our current image */
  imlib_context_set_image(buffer);

  imlib_context_set_drawable(win2); 
  imlib_render_image_on_drawable(0, 0); 


  imlib_context_set_image(buffer);
  imlib_free_image();
  imlib_context_set_font(font);
  imlib_free_font();

  imlib_context_set_image(im_bg);
  imlib_context_set_drawable(win);

  XResizeWindow(disp, win, w, h);
  XSync(disp, False);
  x = -9999;
  y = -9999;
  x = -screenWidth/2;
  y = -screenHeight/2;
  while (1)
  {
    Imlib_Image        temp, temp2;
    do
    {
      XNextEvent(disp, &ev);
      switch (ev.type)
      {
        case Expose:
  attr.override_redirect=True;
 
//win=XCreateWindow(disp,DefaultRootWindow(disp),screenX,screenY,screenWidth,screenHeight,0,CopyFromParent,InputOutput,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask|CWBorderPixel|CWSaveUnder|CWColormap|CWBackPixel,&attr);
  win=XCreateWindow(disp,DefaultRootWindow(disp),screenX,screenY,screenWidth,screenHeight,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);


//   win =  XCreateSimpleWindow(disp, DefaultRootWindow(disp), 0, 0, 100, 100, 0, 0, 0);

  XSelectInput(disp, win, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);

  XLowerWindow(disp,win);

   /**
    * Start rendering
    */

  imlib_context_set_display(disp);
  imlib_context_set_visual(vis);
  imlib_context_set_colormap(cm);
  imlib_context_set_drawable(win);
  imlib_context_set_dither(1);
  imlib_context_set_blend(0);
  imlib_context_set_color_modifier(NULL);

//--
  w=screenWidth;
  h=screenHeight;
//  back = imlib_load_image(picname0);
  imlib_context_set_image(back);
  buffer = imlib_create_cropped_scaled_image(0, 0,imlib_image_get_width() ,imlib_image_get_height() , w , h);

//  im_bg1 = imlib_load_image(picname1);
//  if (strstr(picname2,(char *)"N/A")!=0)
//    im_bg2 = imlib_load_image(picname2);
  imlib_context_set_image(im_bg1);
  is=imlib_image_get_width();
  ih=imlib_image_get_height();
  d1=screenWidth-is;
  d1=d1/2;
  d2=screenHeight-ih;
  d2=d2/2;


  imlib_context_set_image(im_bg1);
  imlib_context_set_blend(1);
  imlib_context_set_image(back);
  imlib_render_image_on_drawable(0, 0);
  imlib_context_set_image(im_bg1);
  imlib_render_image_on_drawable_at_size(d1-1, d2-1,is+2,ih+2);
  bigback=imlib_create_image_from_drawable( 0,0,0,w,h,1);

  if (strstr(picname2,(char *)"N/A")!=0)
  {
    imlib_context_set_blend(1);
    imlib_context_set_image(im_bg2);
    imlib_render_image_on_drawable_at_size(d1-1, d2-1,is+2,ih+2);
    bigback=imlib_create_image_from_drawable( 0,0,0,w,h,1);
  }  

  imlib_context_set_image(back);
  imlib_render_image_on_drawable(0, 0);
  if (strstr(picname2,(char *)"N/A")!=0)
  {
    imlib_context_set_image(im_bg1);
    imlib_render_image_on_drawable(d1-10, d2);
    imlib_context_set_image(im_bg2);
    imlib_render_image_on_drawable(d1+10, d2);
  } else {
    imlib_context_set_image(im_bg1);
    imlib_render_image_on_drawable(d1, d2);
  }
  back=imlib_create_image_from_drawable( 0,0,0,w,h,1);
  XMapWindow(disp, win);

  buffer = imlib_create_image(1000, 30);  
  font = imlib_load_font("Vera/8");
  imlib_context_set_font(font);
  imlib_context_set_color(0, 0, 0, 255);
  sprintf(text,title);
  imlib_get_text_size(text, &text_w, &text_h);
  text_h2=text_h;
  text_h=text_h*4+10;
  text_w=screenWidth;
  if (text_w>screenWidth)
    text_w=screenWidth;
  attr.override_redirect=True;
 
//  win2=XCreateWindow(disp,DefaultRootWindow(disp),screenX,screenY,text_w+10,text_h+4,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);
//  XLowerWindow(disp,win2);
//  XLowerWindow(disp,win);
//  XMapWindow(disp, win2);
//  XMapWindow(disp, win);
  imlib_context_set_drawable(win2); 
   
  //           imlib_context_set_image(buffer);

             /* draw the range */
  imlib_context_set_image(buffer);
  imlib_image_fill_color_range_rectangle(0,0, text_w*4, text_h*2,
                                                   -45.0);
             /* free it */
        //     imlib_free_color_range();

  imlib_context_set_image(buffer);
  
  imlib_render_image_on_drawable(0, 0); 


  imlib_context_set_image(buffer);
  imlib_context_set_font(font);
  imlib_context_set_color(0, 0, 0, 255);
  imlib_text_draw(5,2,text1);
  imlib_text_draw(5,text_h2+4,text2);
  imlib_text_draw(5,text_h2*2+6,text3);
  imlib_text_draw(5,text_h2*3+8,text4);

             /* set the buffer image as our current image */
  imlib_context_set_image(buffer);

  imlib_context_set_drawable(win2); 
  imlib_render_image_on_drawable(0, 0); 


  imlib_context_set_image(buffer);
  imlib_free_image();
  imlib_context_set_font(font);
  imlib_free_font();

  imlib_context_set_image(im_bg);
  imlib_context_set_drawable(win);

  XResizeWindow(disp, win, w, h);

          XSync(disp, False);
          break;
        case MotionNotify:
          x = ev.xmotion.x;
          y = ev.xmotion.y;
        default:
          break;
       case EnterNotify:		
          x = ev.xmotion.x;
          y = ev.xmotion.y;

          break;

       case LeaveNotify:		
          x = -screenWidth/2;
          y = -screenHeight/2;	

//          mytoggle = 0;

//          XDestroyWindow(disp,win2);
	
          break;

       case ButtonPress:				
         if(ev.xbutton.button==1)
		{
            exposelist();
		}
         if(ev.xbutton.button==3)
		{
                                    /* if we click anywhere in the window, exit */
//                                   exit(0);
          break;
        }

    }
  }
  while (XPending(disp));
    imlib_context_set_image(back);
    imlib_context_set_drawable(win);
    temp = imlib_clone_image();
    imlib_context_set_image(temp);
    imlib_apply_filter
    ("bump_map_point(x=[],y=[],map=""blend.jpg);", &xl, &yl);
    imlib_context_set_image(back);
    imlib_render_image_on_drawable(0, 0);
    temp2 = im_bg;
    im_bg = temp;
    imlib_context_set_image(im_bg);
    imlib_context_set_blend(1);
    imlib_render_image_on_drawable(0, 0);
    im_bg = temp2;
    imlib_context_set_image(temp);
    imlib_free_image();

}

   return 0;
}

void exposelist(void){
  //printf("exposelist\n");
  char app[2000];
  sprintf(app,"%s &",appToRun);
  system(app);
}
